#ifndef BODY_H_
#define BODY_H_

#include <vmath.h>
#include "chipmunk.h"

class Body {
private:
	cpBody *cpbody;

public:
	Body(float mass = 1.0, float inertia = 1.0);
	~Body();

	cpBody *chipmunk_body() const;

	void set_position(const Vector2 &pos);
	Vector2 get_position() const;

	void set_velocity(const Vector2 &vel);
	Vector2 get_velocity() const;

	void set_angle(float angle);
	float get_angle() const;

	void set_mass(float mass);
	float get_mass() const;

	void set_inertia(float inertia);
	float get_inertia() const;

	void apply_impulse(const Vector2 &imp, const Vector2 &offs = Vector2(0, 0));
	void apply_force(const Vector2 &f, const Vector2 &offs = Vector2(0, 0));
	void reset_forces();

	Vector2 world_to_local(const Vector2 &v);
	Vector2 local_to_world(const Vector2 &v);
};

#endif	// BODY_H_
