#include "chipper.h"
#include "chipmunk.h"


float calc_moment_circle(float m, float r, const Vector2 &offs)
{
	return cpMomentForCircle(m, r, r, chip_vec2(offs));
}

float calc_moment_wheel(float m, float r1, float r2, const Vector2 &offs)
{
	return cpMomentForCircle(m, r1, r2, chip_vec2(offs));
}

float calc_moment_segment(float m, const Vector2 &a, const Vector2 &b)
{
	return cpMomentForSegment(m, chip_vec2(a), chip_vec2(b));
}

float calc_moment_polygon(float m, const Vector2 *varr, int num_verts, const Vector2 &offs)
{
	cpVect *vtmp = new cpVect[num_verts];
	for(int i=0; i<num_verts; i++) {
		vtmp[i].x = varr[i].x;
		vtmp[i].y = varr[i].y;
	}

	float res = cpMomentForPoly(m, num_verts, vtmp, chip_vec2(offs));
	delete [] vtmp;
	return res;
}
