#ifndef CHIPPER_H_
#define CHIPPER_H_

#include "simspace.h"
#include "shape.h"
#include "body.h"
#include "constraint.h"
#include "chip_math.h"

#define CHIPPER_INF	INFINITY

float calc_moment_circle(float m, float r, const Vector2 &offs = Vector2(0, 0));
float calc_moment_wheel(float m, float r1, float r2, const Vector2 &offs = Vector2(0, 0));
float calc_moment_segment(float m, const Vector2 &a, const Vector2 &b);
float calc_moment_polygon(float m, const Vector2 *varr, int num_verts, const Vector2 &offs = Vector2(0, 0));

#endif	// CHIPPER_H_
