#include "palette.h"

#define RGB(x, y, z)	Color((float)x / 255.0, (float)y / 255.0, (float)z / 255.0)
static Color palette[] = {
	RGB(230, 160, 140),
	RGB(165, 230, 190),
	RGB(130, 205, 235),
	RGB(245, 165, 200),
	RGB(140, 100, 95),
	RGB(120, 195, 185),
	RGB(220, 215, 155),
	RGB(240, 140, 145)
};

static const char *col_names[] = {
	"pink",
	"green",
	"blue",
	"purple",
	"brown",
	"teal",
	"yellow",
	"red-ish"
};

#define CLAMP(x, low, high)	\
	((x) < (low) ? (low) : ((x) > (high) ? (high) : (x)))

const Color &get_color(int chalk)
{
	int idx = CLAMP(chalk, 0, NUM_CHALKS - 1);
	return palette[idx];
}

const char *get_color_name(int col)
{
	if(col < 0 || col >= NUM_CHALKS) {
		return "invalid color";
	}
	return col_names[col];
}
