#ifndef POLYLINE_H_
#define POLYLINE_H_

#include <vector>
#include "vmath.h"

typedef Vector4 Color;

class PolyLine {
private:
	Color color;
	float width;
	std::vector<Vector2> points;

	mutable float arc_length;

public:
	PolyLine();

	void set_point(int idx, const Vector2 &pt);
	const Vector2 &get_point(int idx) const;
	int get_point_count() const;

	void set_width(float width);
	float get_width() const;

	void set_color(const Color &col);
	const Color &get_color() const;

	void add_point(const Vector2 &pt, float min_dist = 0.0);

	float get_length() const;

	Vector2 get_curve_point(float t) const;
	Vector2 get_curve_normal(float t) const;

	void draw(float samples_per_unit = 25.0) const;
};

#endif	// POLYLINE_H_
