#ifndef SDLGLUT_H_
#define SDLGLUT_H_

#include <SDL.h>

#define GLUT_INDEX			1
#define GLUT_RGB			0
#define GLUT_RGBA			0

#define GLUT_SINGLE			0
#define GLUT_DOUBLE			(1 << 1)

#define GLUT_ACCUM			(1 << 2)
#define GLUT_ALPHA			(1 << 3)
#define GLUT_DEPTH			(1 << 4)
#define GLUT_STENCIL		(1 << 5)
#define GLUT_MULTISAMPLE	(1 << 6)
#define GLUT_STEREO			(1 << 7)
#define GLUT_LUMINANCE		(1 << 8)

#define GLUT_LEFT_BUTTON	0
#define GLUT_MIDDLE_BUTTON	1
#define GLUT_RIGHT_BUTTON	2

#define GLUT_DOWN		0
#define GLUT_UP			1

/* special key codes */
#define GLUT_KEY_UP			273
#define GLUT_KEY_DOWN		274
#define GLUT_KEY_RIGHT		275
#define GLUT_KEY_LEFT		276
#define GLUT_KEY_INSERT		277
#define GLUT_KEY_HOME		278
#define GLUT_KEY_END		279
#define GLUT_KEY_PAGE_UP	280
#define GLUT_KEY_PAGE_DOWN	281
#define GLUT_KEY_F1			282
#define GLUT_KEY_F2			283
#define GLUT_KEY_F3			284
#define GLUT_KEY_F4			285
#define GLUT_KEY_F5			286
#define GLUT_KEY_F6			287
#define GLUT_KEY_F7			288
#define GLUT_KEY_F8			289
#define GLUT_KEY_F9			290
#define GLUT_KEY_F10		291
#define GLUT_KEY_F11		292
#define GLUT_KEY_F12		293
#define GLUT_KEY_F13		294
#define GLUT_KEY_F14		295
#define GLUT_KEY_F15		296

/* glutSetCursor parameters */
#define GLUT_CURSOR_RIGHT_ARROW			0x0000
#define GLUT_CURSOR_LEFT_ARROW			0x0001
#define GLUT_CURSOR_INFO				0x0002
#define GLUT_CURSOR_DESTROY				0x0003
#define GLUT_CURSOR_HELP				0x0004
#define GLUT_CURSOR_CYCLE				0x0005
#define GLUT_CURSOR_SPRAY				0x0006
#define GLUT_CURSOR_WAIT				0x0007
#define GLUT_CURSOR_TEXT				0x0008
#define GLUT_CURSOR_CROSSHAIR			0x0009
#define GLUT_CURSOR_UP_DOWN				0x000A
#define GLUT_CURSOR_LEFT_RIGHT			0x000B
#define GLUT_CURSOR_TOP_SIDE			0x000C
#define GLUT_CURSOR_BOTTOM_SIDE			0x000D
#define GLUT_CURSOR_LEFT_SIDE			0x000E
#define GLUT_CURSOR_RIGHT_SIDE			0x000F
#define GLUT_CURSOR_TOP_LEFT_CORNER		0x0010
#define GLUT_CURSOR_TOP_RIGHT_CORNER	0x0011
#define GLUT_CURSOR_BOTTOM_RIGHT_CORNER	0x0012
#define GLUT_CURSOR_BOTTOM_LEFT_CORNER	0x0013
#define GLUT_CURSOR_INHERIT				0x0064
#define GLUT_CURSOR_NONE				0x0065
#define GLUT_CURSOR_FULL_CROSSHAIR		0x0066

/* glutGet parameters */
#define GLUT_WINDOW_X		0
#define GLUT_WINDOW_Y		1
#define GLUT_WINDOW_WIDTH	2
#define GLUT_WINDOW_HEIGHT	3
#define GLUT_ELAPSED_TIME	4

extern SDL_Surface *fbsurf;

void glutInit(int *argcp, char **argv);
void glutInitWindowSize(int w, int h);
void glutInitDisplayMode(unsigned int mode);
void glutCreateWindow(const char *title);

void glutGameModeString(const char *mode_str);
void glutEnterGameMode(void);

void glutDisplayFunc(void (*func)(void));
void glutIdleFunc(void (*func)(void));
void glutReshapeFunc(void (*func)(int, int));
void glutKeyboardFunc(void (*func)(unsigned char, int, int));
void glutKeyboardUpFunc(void (*func)(unsigned char, int, int));
void glutSpecialFunc(void (*func)(int, int, int));
void glutSpecialUpFunc(void (*func)(int, int, int));
void glutMouseFunc(void (*func)(int, int, int, int));
void glutMotionFunc(void (*func)(int, int));
void glutPassiveMotionFunc(void (*func)(int, int));

void glutMainLoop(void);
void glutSwapBuffers(void);
void glutPostRedisplay(void);

void glutSetCursor(int cursor);

int glutGet(unsigned int what);

#endif	// SDLGLUT_H_
